<style>
	:global(*){
		padding: 0;
		margin: 0;
		font-family: consolas, monospace;
		font-size: 1em;
	}
	:global(html, body){
		width: 100%;
		height: 100%;
		display: flex;
		flex-direction: column;
		background-color: #222;
		color: #FFF;
	}

	nav{
		flex: 0 1 auto;
		position: fixed;
		width: 100%;
		background-color: #222;
		padding: 0.3em 0em;
	}
	main{
		margin-top: 4em;
		flex: 1 1 auto;
		display: flex;
		flex-wrap: wrap;
		justify-content: space-evenly;
		align-items: center;
		align-content: stretch;
	}
</style>
<script>
	import Controls from './controls.svelte'
	import Timed from './timed.svelte'
	import Toggle from './util/toggle.svelte'
	import Card from './card.svelte'

	import importAll from './util/importAll'

	const allCards = {}
	const tags = new Map()
	Object.entries(importAll(require.context('../asset/card', true, /\.svg/))).forEach(([key])=>{
		const name = key.replace(/-/g, ' ').match(/\/([\s\w]+?)\.?\w*?$/m)[1]
		allCards[name] = {name, src: key}
	})
	Object.entries(importAll(require.context('../asset/card', true, /\.json/))).forEach(([key, value])=>{
		const name = key.replace(/-/g, ' ').match(/\/([\s\w]+?)\.?\w*?$/m)[1]
		if(allCards[name]) Object.assign(allCards[name], value)
		for(const tag of value.tag){
			if(!tags.has(tag)) tags.set(tag, 0);
			tags.set(tag, tags.get(tag)+1)
		}
	})

	let availableCards = [...Object.values(allCards)]
	const filterCards = tags=> availableCards = (!tags || !tags.size)?
		[...Object.values(allCards)]:
		[...Object.values(allCards).filter(card=>{
			if(!card.tag) return false
			for(const tag of card.tag){
				if(tags.has(tag)) return true
			}
		})]

	let cards = []
	let message
</script>
<nav>
	<Controls
		on:draw={()=>{
			if(cards.length >= availableCards.length) return message = "you already have all the cards" //smh
			let randomCard
			do{
				randomCard = availableCards[availableCards.length*Math.random() | 0]
			}while(cards.find(c=> c===randomCard)) //no duplicates
			cards = [...cards, randomCard]
		}}
		on:reset={()=> cards = []}
	>
	<Toggle
		values={[...tags].map(([k, v])=>({text: k, subscript: v}))}
		on:change={({detail: set})=> filterCards(set)}
	/>
	<Timed bind:message/>
	</Controls>
</nav>
<main>
	{#each cards as card, index}
		<Card src={card.src} name={card.name} on:remove={()=>{
			cards.splice(index, 1)
			cards = [...cards]
		}}/>
	{/each}
</main>
